#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../libweb/webutil.h"
#include "aofi.h"

/*----------------------------------------------------------------------------*/

/*
 * Fields are: f_author f_date f_title f_subject f_url f_affil
 */
static void DumpRecord( int n, char* buf )
{
   sprintf( BF, "<p><a href=\"http://www.aofi.com/articles/%s\">", f_url );
   sprintf( BF, "<i>%s</i></a> %s<br>%c", f_title, f_date, 10 );
   sprintf( BF, "%s, %s<br>%c", authorBits[atoi(f_author)],
            affilBits[atoi(f_affil)], 10 );
}

/*----------------------------------------------------------------------------*/

static int BuildQuery( entry entries[], int m )
{
   int x, n = 0;

  /*
   * First, set up schema and initialize query.
   * Fields are: f_author f_date f_title f_subject f_url f_affil
   */
   dbSchemaT( fields );
   dbQuery( "0|0/0/0 0:0:0||0||0" );

  /*
   *  Next, build query using form input values.
   */
   for( x = 0; x <= m; x++ ) /*EGN: what if m = 0??*/
   {
      if( strcmp( entries[x].name, "" ) && strcmp( entries[x].val, "" ) )
      {
         if( dbUpdateQuery( entries[x].name, entries[x].val, fields, masks ) )
         {
            n++;
         }
         else
         {
            if( strcmp( entries[x].name, "subjectAnd" ) == 0 )
               dbSetAndOr( "subject", entries[x].val, fields );
            if( strcmp( entries[x].name, "date_compar" ) == 0 )
               dbSetCompar( "date", entries[x].val, fields );
         }
      }
   }

   return n;
}

/*----------------------------------------------------------------------------*/

#define MAXHITS 999999999

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   int i, m = 0, first = 0, maxhits = MAXHITS, next = 0;

   printf( "Content-type: text/html%c%c", 10, 10 );

   /* Parse command line arguments */
   for( i = 1; i < argc; i++ )
      ParseArg( &first, &maxhits, &m, argv[i], entries );

   m = m ? m-1 : CGIInit( entries );

   printf( "<header>%c", 10 );
   printf( "<title>Art of Investment Article Search Results</title>%c", 10 );
   printf( "</header>%c<body>%c",
   10, 10 );
   printf( "<h2>Query Results</h2>%c<hr size=\"2\">%c", 10, 10 );

   BuildQuery( entries, m );

   /*if( ! empty_query )*/
   {
      char path[256];
      FILE* fp;
      int n;

      sprintf( path, "%s/%s/lib/aofi.txt", ROOT, CLIENT );
      fp = fopen( path, "r" );
      n = dbDumpHits( fp, first, maxhits, &next, 0, &DumpRecord );
      fclose( fp );

      if( next )
      {
         printf( "<p><hr>%c", 10 );
         dbNextAnchor( "/cgi-bin/redbook", next, maxhits ? maxhits : MAXHITS,
                       entries, m );
      }

      printf( "<p><hr size=\"2\">%c", 10 );

      printf( "<i>Query generated " );
      printf( "<b>%s</b> hits and took ", CommaNumber(n) );
      printf( "<b>%s</b> seconds to scan ", CommaNumber(dbTotalSeconds) );
      printf( "<b>%s</b> bytes of data and to send ", CommaNumber(dbTotalBIn) );
      printf( "<b>%s</b> bytes of results.</i>%c", CommaNumber(dbTotalBOut),
      10 );
      printf( "</body>%c", 10 );
   }
/*
   else
   {
      printf(
      "You did not select any search criteria.  Please try again.<BR>%c", 10 );
      printf( SIG );
      printf( "</body>%c", 10 );
   }
*/
   return 0;
}

/*----------------------------------------------------------------------------*/
