#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../libweb/webutil.h"
#include "redbook.h"

/*----------------------------------------------------------------------------*/

static void DumpRecord( int n, char* buf )
{
   if( n > 0 ) sprintf( BF, "<hr>%c", 10 );
   if( strcmp( f_contact, "" ) )
      sprintf( BF, "%s<br>%c", f_contact, 10 );
   if( strcmp( f_org, "" ) )
      sprintf( BF, "%s<br>%c", f_org, 10 );
   {
      int i = atoi( f_city );
      int j = atoi( f_prov );

      if( i != 0 )
      {
         if( strcmp( f_street, "" ) )
            sprintf( BF, "%s<br>%c", f_street, 10 );
         sprintf( BF, "%s, %s<br>%c", cityBits[i], provinceBits[j], 10 );
         if( strcmp( f_postal, "" ) )
            sprintf( BF, "%s<br>%c", f_postal, 10 );
      }
   }
   if( strcmp( f_tel, "" ) )
      sprintf( BF, "%s%c", f_tel, 10 );
   if( strcmp( f_descr, "" ) )
      sprintf( BF, "<blockquote>%s</blockquote>%c", f_descr, 10 );
}

/*----------------------------------------------------------------------------*/

static int BuildQuery( entry entries[], int m )
{
   int x, n = 0;

  /*
   *  First, set up schema and initialize query.
   */
   dbSchemaT( fields );
   dbQuery( "|||||||0|0||||||" );

  /*
   *  Next, build query using form input values.
   */
   for( x = 0; x <= m; x++ ) /*EGN: what if m = 0??*/
   {
      if( strcmp( entries[x].name, "" ) && strcmp( entries[x].val, "" ) )
      {
         if( dbUpdateQuery( entries[x].name, entries[x].val, fields, masks ) )
         {
            n++;
         }
      }
   }

   return n;
}

/*----------------------------------------------------------------------------*/

#define MAXHITS 10

int main( int argc, char* argv[] )
{
   entry entries[MAX_ENTRIES];
   int i, m = 0, first = 0, maxhits = MAXHITS, next = 0;

   printf( "Content-type: text/html%c%c", 10, 10 );

   /* Parse command line arguments */
   for( i = 1; i < argc; i++ )
      ParseArg( &first, &maxhits, &m, argv[i], entries );

   m = m ? m-1 : CGIInit( entries );

   printf( "<header>%c", 10 );
   printf( "<title>Search the RedBook - Query Results</title>%c", 10 );
   printf( "</header>%c<body>%c",
   10, 10 );
   printf( "<h2>Query Results</h2>%c<hr size=\"2\">%c", 10, 10 );

   BuildQuery( entries, m );

   /*if( ! empty_query )*/
   {
      char path[256];
      FILE* fp;
      int n;

      sprintf( path, "%s/%s/lib/redbook.txt", ROOT, CLIENT );
      fp = fopen( path, "r" );
      n = dbDumpHits( fp, first, maxhits, &next, 0, &DumpRecord );
      fclose( fp );

      if( next )
      {
         printf( "<p><hr>%c", 10 );
         dbNextAnchor( "/cgi-bin/redbook", next, maxhits ? maxhits : MAXHITS,
                       entries, m );
      }

      printf( "<p><hr size=\"2\">%c", 10 );

      printf( "<i>Query generated " );
      printf( "<b>%s</b> hits and took ", CommaNumber(n) );
      printf( "<b>%s</b> seconds to scan ", CommaNumber(dbTotalSeconds) );
      printf( "<b>%s</b> bytes of data and to send ", CommaNumber(dbTotalBIn) );
      printf( "<b>%s</b> bytes of results.</i>%c", CommaNumber(dbTotalBOut),
      10 );
      printf( "</body>%c", 10 );
   }
/*
   else
   {
      printf(
      "You did not select any search criteria.  Please try again.<BR>%c", 10 );
      printf( SIG );
      printf( "</body>%c", 10 );
   }
*/
   return 0;
}

/*----------------------------------------------------------------------------*/
