#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "../libweb/webutil.h"
#include "../libweb/db++.h"
#include "food.h"
#include "restaura.h"

/*----------------------------------------------------------------------------*/

static char* footer[] =
{
   "<p>\nToolBar\nFooter\n",
   0
};

static char* header[] =
{
   "#include \"defs.h\"\n",
   "Header(- Database Statistics)\n",
   "<h2>Database Statistics</h2>\n",
   0
};

/*----------------------------------------------------------------------------*/

#define STAT_FMT "%-25s %4d records, %4.1f%% %-s%c"

static void Category( char* title, char* s[], int n[], int ncat, int nitems )
{
   int i;
   printf( "<h3>Breakdown by %s:</h3>%c<pre>%c", title, 10, 10 );
   for( i = 0; i < ncat; i++ )
   {
      float p = (float) n[i] / (float) nitems;
      int b = p * 50 + 0.5;
      char bar[51] = "********************";
      bar[b] = 0;
      printf( STAT_FMT, s[i], n[i],
      100.0 * (float) n[i] / (float) nitems, bar, 10 );
   }
   printf( "</pre>%c", 10 );
}

/*----------------------------------------------------------------------------*/

static void DumpStats( FILE* fp )
{
   char buf[512];
   int nhoods[30], regions[5], types[22], prices[5];

   int i, n = 0;

   for( i = 0; i < 30; i++ ) nhoods[i] = 0;
   for( i = 0; i <  5; i++ ) regions[i] = 0;
   for( i = 0; i < 22; i++ ) types[i] = 0;
   for( i = 0; i <  5; i++ ) prices[i] = 0;

   engine.AddFields( fields );

   while( fgets( buf, 512, fp ) != 0 )
   {
      char nhoodm[15], regionm[15], typem[15], pricem[15];
      int nhood, region, price;
      long int type;

      engine.ClearRecord( 0 );
      engine.SetRecord( buf, 0 );

      engine.Write( 3, nhoodm,  0 );	nhood  = atoi( nhoodm  );
      engine.Write( 4, regionm, 0 );	region = atoi( regionm );
      engine.Write( 7, typem,   0 );	type   = atol( typem );
      engine.Write( 8, pricem,  0 );	price  = atoi( pricem  );

      nhoods[nhood]++;
      regions[region]++;
      for( i = 0; i < 22; i++ )
         if( pow2( i ) & type )
            types[i]++;
      prices[price]++;

      n++;
   }
   printf( "<h3>Total number of records:</h3>%c", 10 );
   printf( "<pre>%d</pre>%c", n, 10 );

   Category( "price", priceBits, prices, 5, n );
   Category( "neighbourhood", nhoodBits, nhoods, 30, n );
   Category( "region", regionBits, regions, 5, n );
   Category( "cuisine type", typeBits, types, 22, n );
}

/*----------------------------------------------------------------------------*/

int main( void )
{
   char date[80];
   FILE *fp;

   fp = popen( "date -u", "r" );
   fgets( date, 80, fp );
   pclose( fp );

   fp = fopen( "../../lib/restaura.txt", "r" );

   PrintText( header );
   printf( "<p>Compiled on <i>%s</i>\n<hr>\n", date );
   DumpStats( fp );
   PrintText( footer );

   fclose( fp );
   return 0;
}

/*----------------------------------------------------------------------------*/
